#include <Windows.h> 
#include <shlobj.h> // Browse Folder.cpp > Browse for folder stuff
#include <shlwapi.h> // Path related function 
#include <commctrl.h> // common controls
#include "resource.h"

// DLL linkage
#pragma comment( lib, "comctl32.lib" )
#pragma comment( lib, "shlwapi.lib" )

// Common Functions
void ErrMsg(HWND hwnd,LPSTR lpstrError);
DWORD GetFileSize(LPSTR szFilePath);
int GetPercent(DWORD dwNewValue,DWORD dwMax);
void GetFilePath(HWND hwnd,HWND hTextBox);
void GetFolderName(HWND hwndOwner,HWND hwndTextBox);
BOOL CheckEntry(HWND hwndOwnerDlg,int nId,LPSTR lpstrErrorMsg);

// Call back functions(used in Entry Point.cpp)
LRESULT CALLBACK DlgProcJoin(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);

// Used in only Join File.cpp

#define ERR_MSG_FILE "Please choose a valid file path."
#define ERR_MSG_FOLDER "Please choose a valid output folder path."
#define ERR_MSG_OPENING "Error while opening input file."
#define ERR_MSG_CREATING "Cant create new file."

#define JOIN_BUFFER 4096

void OnJoinButton(void);
void JoinStart(void);
void JoinFile(void);
DWORD GetTotalSize(LPSTR szFilePath);
HANDLE OpenChunkFile(LPSTR szFilePath,DWORD dwNumber);
DWORD WriteOutFile(HANDLE hChunkFile,HANDLE hfOut,DWORD dwTotalFileSize,DWORD PreWritten,HWND hwndPBar);

LRESULT CALLBACK DlgProcJoining(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK DlgProcAbout(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);

// Used in only Common Functions.cpp
BOOL IsEmpty(HWND hwnd);

// Optional :: link dynamic (dll) C/C++ run time library
//#pragma comment(linker, "/nodefaultlib:libc.lib")//Disable C run-time library static linkage.
//#pragma comment(linker, "/defaultlib:MSVCRT.LIB")//Link dynamic C run-time library {msvcrt.dll). 
//#pragma comment(linker, "/OPT:NOWIN98")//Disable fast load future for Window 98