#include "Split File.h"

//ex
#ifndef BIF_NEWDIALOGSTYLE 
#define BIF_NEWDIALOGSTYLE 0x0040 
#endif 
#ifndef BIF_USENEWUI
#define BIF_USENEWUI           (BIF_NEWDIALOGSTYLE | BIF_EDITBOX)
#endif 

BOOL SelectFolderEx(LPTSTR pszSelectedDir,LPTSTR szCaption,HWND hOwner);
//~ex

//BOOL SelectFolder(LPTSTR pszSelectedDir,LPTSTR szCaption,HWND hOwner);

// get folder path into a text box.
void GetFolderName(HWND hwndOwner,HWND hwndTextBox)
{
	char pstrDir[MAX_PATH];

	// select a folder
	if (SelectFolderEx(pstrDir,NULL,hwndOwner)==TRUE)
		SetWindowText(hwndTextBox,pstrDir);// if folder path is selected then set it to text box.
}
/*
BOOL SelectFolder(LPTSTR pszSelectedDir,LPTSTR szCaption,HWND hOwner)
{
    //The BROWSEINFO struct Contains parameters for the SHBrowseForFolder function .
	BROWSEINFO      browseInfo;

    BOOL            bValid = FALSE; 
	
	//fill browseInfo (BROWSEINFO struct) with zeros
	ZeroMemory(&browseInfo, sizeof(BROWSEINFO));

    browseInfo.ulFlags =  BIF_RETURNFSANCESTORS;
	browseInfo.hwndOwner= hOwner;
	browseInfo.lpszTitle= szCaption;
  
	// show  the browse for folder dialog box 
	LPITEMIDLIST pIDL = SHBrowseForFolder(&browseInfo);

   if(pIDL != NULL)
   {
	    // get the path of selected folder  
	   if((SHGetPathFromIDList(pIDL,pszSelectedDir)) != 0) 
            bValid = TRUE;
		  
	      //free the item id list allocated by SHBrowseForFolder
		  CoTaskMemFree(pIDL);
    }

    return(bValid);
}
*/

BOOL SelectFolderEx(LPTSTR pszSelectedDir,LPTSTR szCaption,HWND hOwner)
{
    
	//The BROWSEINFO struct Contains parameters for the SHBrowseForFolder function .
	BROWSEINFO      browseInfo;

    BOOL            bValid = FALSE,bOle=TRUE; 

    //  Required COM for BIF_USENEWUI Flag
	if ( (OleInitialize(NULL))==S_FALSE)
			bOle=FALSE;
	
	//fill browseInfo (BROWSEINFO struct) with zeros
	ZeroMemory(&browseInfo, sizeof(BROWSEINFO));

    browseInfo.ulFlags =  BIF_USENEWUI;
	browseInfo.hwndOwner= hOwner;
	browseInfo.lpszTitle= szCaption;
  
	// show  the browse for folder dialog box 
	LPITEMIDLIST pIDL = SHBrowseForFolder(&browseInfo);

   if(pIDL != NULL)
   {

	   // get the path of selected folder
		  if((SHGetPathFromIDList(pIDL,pszSelectedDir)) != 0) 
            bValid = TRUE;
                 
		//free the item id list allocated by SHBrowseForFolder
		CoTaskMemFree(pIDL);
    }

   // first check if COM library initializes by us then closes the COM library 
  if (bOle==TRUE)
	  OleUninitialize();

    return(bValid);
}

